Attribute VB_Name = "modFileSystem"

Function DoesDirectoryExist(LongFileName) As Boolean 'good
If Trim(LongFileName) = "" Then Exit Function

On Error Resume Next
lastdir = CurDir
ChDir LongFileName
DoesDirectoryExist = 1 - Sgn(Err)
ChDir lastdir
End Function

Function DoesFileExist(LongFileName) As Boolean 'good
On Error Resume Next
freefilenumber = FreeFile
Open LongFileName For Input As freefilenumber
 DoesFileExist = 1 - Sgn(Err)
Close freefilenumber
End Function

Function DoesFileNameHaveExtension(LongFileName) As Integer 'good
On Error Resume Next
For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "*" And lastwildcard = 0 Then lastwildcard = v
 If Mid(LongFileName, v, 1) = "." And lastdot = 0 Then lastdot = v
 If lastdot > lastwildcard And lastdot > lastbackslash Or lastwildcard > lastdot And lastdot > lastbackslash Then DoesFileNameHaveExtension = v: Exit For
Next
End Function

Function DoesFileNameHaveWildcardExtension(LongFileName) As Integer 'good
On Error Resume Next
For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "*" And lastwildcard = 0 Then lastwildcard = v
 If Mid(LongFileName, v, 1) = "." And lastdot = 0 Then lastdot = v
 If lastdot = lastwildcard + 1 And lastwildcard = lastbackslash + 1 Or lastwildcard = lastdot + 1 And lastdot > lastbackslash Then DoesFileNameHaveWildcardExtension = v: Exit For
Next
End Function

'This give only the extension without the dot and wildcard.
Function GetExtensionFromFileName(LongFileName, DefaultExtension) 'good
On Error Resume Next
For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "." And lastdot = 0 Then lastdot = v
 If lastdot > lastbackslash Then
  GetExtensionFromFileName = Mid(LongFileName, lastdot + 1)
  Exit Function
 End If
Next

For v = Len(DefaultExtension) To 1 Step -1
 If Mid(DefaultExtension, v, 1) = "." Then
  GetExtensionFromFileName = Mid(DefaultExtension, v + 1)
  Exit Function
 End If
Next

GetExtensionFromFileName = DefaultExtension
End Function

Function GetWildCardExtensionFromFileName(LongFileName, DefaultWildCardExtension) 'kinda good
On Error Resume Next
For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "*" And lastwildcard = 0 Then lastwildcard = v
 If lastwildcard > lastbackslash Then
  GetWildCardExtensionFromFileName = Mid(LongFileName, lastwildcard)
  Exit Function
 End If
Next

GetWildCardExtensionFromFileName = DefaultWildCardExtension
End Function

Function GetFileNameWithAddedExtension(LongFileName, DefaultExtension) 'kinda good
On Error Resume Next
For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "." And lastdot = 0 Then lastdot = v
 If lastdot > lastbackslash Then
  GetFileNameWithAddedExtension = LongFileName
  Exit Function
 End If
Next

For v = Len(DefaultExtension) To 1 Step -1
 If Mid(DefaultExtension, v, 1) = "." Then
  GetFileNameWithAddedExtension = LongFileName & Mid(DefaultExtension, v)
  Exit Function
 End If
Next

GetFileNameWithAddedExtension = LongFileName & "." & DefaultExtension
End Function

Function GetFileNameWithCapitalDriveLetter(LongFileName) 'kinda good
FirstColon = InStr(LongFileName, ":")
GetFileNameWithCapitalDriveLetter = UCase(Left(LongFileName, FirstColon)) & Mid(LongFileName, FirstColon + 1)
End Function

'This sub was kinda hard to create.  You might make it better.
Function GetFileNameWithoutExtension(LongFileName, ExtensionToCut) 'good
On Error Resume Next
If ExtensionToCut > "" Then
 For v = Len(ExtensionToCut) To 1 Step -1
  If Mid(ExtensionToCut, v, 1) = "." Then ExtensionToCut = Mid(ExtensionToCut, v + 1): Exit For
 Next
 temp = InStr(LCase(LongFileName), "." & LCase(ExtensionToCut))
 If temp Then
  GetFileNameWithoutExtension = Left(LongFileName, temp - 1)
 Else
  GetFileNameWithoutExtension = LongFileName
 End If
 Exit Function
End If

For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "." And lastdot = 0 Then lastdot = v
 If lastdot > lastbackslash Then
  GetFileNameWithoutExtension = Left(LongFileName, v - 1)
  Exit Function
 End If
Next

GetFileNameWithoutExtension = LongFileName
End Function

Function GetLongFileName(DirectoryPath as string, ShortFileName as string) 'kinda good
On Error Resume Next
For v = Len(directorypath) To 1 Step -1
 If Mid(directorypath, v, 1) <> "\" Then Exit For
Next
directorypath = Left(directorypath, v)

For v = 1 To Len(ShortFileName)
 If Mid(ShortFileName, v, 1) = "\" Then
  ShortFileName = Mid(ShortFileName, v + 1)
  v = v - 1
 Else
  Exit For
 End If
Next

GetLongFileName = DirectoryPath & "\" & ShortFileName
End Function

'This sub is useless unless you want a wildcard extension from a file name.
Function GetExtensionWithWildCardFromFileName(LongFileName, DefaultExtension)
On Error Resume Next
For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "." And lastdot = 0 Then lastdot = v
 If lastdot > lastbackslash Then
  GetExtensionWithWildCardFromFileName = "*" & Mid(LongFileName, lastdot)
  Exit Function
 End If
Next

For v = Len(DefaultExtension) To 1 Step -1
 If Mid(DefaultExtension, v, 1) = "." Then
  GetExtensionWithWildCardFromFileName = "*" & Mid(DefaultExtension, v)
  Exit Function
 End If
Next

GetExtensionWithWildCardFromFileName = "*." & DefaultExtension
End Function

Function GetShortFileName2(LongFileName) 'good
On Error Resume Next

For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "." Then
  If v > 1 Then '?:\?????\.ddd, ?:.ddd
   If Mid(LongFileName, v - 1, 1) = "\" Or Mid(LongFileName, v - 1, 1) = ":" Then
    GetShortFileName2 = Mid(LongFileName, v)
    Exit Function
   End If
  Else '.ddd
   GetShortFileName2 = LongFileName
   Exit Function
  End If
 End If
Next

temp$ = LongFileName
If DoesDirectoryExist(temp$ & "\") Then temp$ = temp$ & "\" 'C:\Windows should return blank.
For v = Len(temp$) To 1 Step -1
 If Mid(temp$, v, 1) = "\" Or Mid(temp$, v, 1) = ":" Then
  GetShortFileName2 = Mid(temp$, v + 1)
  Exit Function
 End If
Next

GetShortFileName2 = LongFileName
End Function

Function GetTrimmedCommandLine(CMString$)
If Left(CMString$, 1) = Chr(34) Then
 result$ = Mid(CMString$, 2)
ElseIf Left(LTrim(CMString$), 1) = Chr(34) Then
 result$ = Mid(LTrim(CMString$), 2)
Else
 result$ = CMString$
End If

If Right(result$, 1) = Chr(34) Then
 result$ = Left(result$, Len(result$) - 1)
ElseIf Right(RTrim(result$), 1) = Chr(34) Then
 result$ = Left(RTrim(result$), Len(RTrim(result$)) - 1)
End If

GetTrimmedCommandLine = result$
End Function

Function GetValidDirectoryName(LongFileName, DefaultDirectoryName) 'good, I think
On Error Resume Next
lastdir = CurDir
For v = Len(LongFileName) To 1 Step -1
 temp$ = Left(LongFileName, v)
 If Mid(LongFileName, v, 1) = "\" Or Mid(LongFileName, v, 1) = ":" Or v = Len(LongFileName) Then
  Err = 0
  ChDir temp$
  If Err = 0 Then
   ChDir lastdir
   GetValidDirectoryName = temp$
   Exit Function
  End If
 End If
Next
ChDir lastdir
GetValidDirectoryName = DefaultDirectoryName
End Function

Function GetValidDriveName(LongFileName, DefaultDriveName) 'good
On Error Resume Next
FirstColon = InStr(LongFileName, ":")
If FirstColon Then
 temp$ = Mid(LongFileName, FirstColon - 1, 2)
 lastdrive = CurDir
 ChDrive temp$
 If Err = 0 Then
  ChDrive lastdrive
  GetValidDriveName = temp$
  Exit Function
 End If
'I'm not going to use code below because I don't know if they have drives with more than 1 letter.
' For v = FirstColon To 1 Step -1
'  temp$ = Mid(LongFileName, v, FirstColon - v + 1)
'  lastdrive = CurDir
'  ChDrive temp$
'  If Err = 0 Then
'   ChDrive lastdrive
'   GetValidDriveName = temp$
'   Exit Function
'  End If
' Next
 ChDrive lastdrive
End If

GetValidDriveName = DefaultDriveName
End Function
